<template>
    <div class="ProductInfo">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">产品档案</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getProductInfoList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="code" label="ID编码"></el-table-column>
                    <el-table-column prop="productName" label="产品名称"></el-table-column>
                    <el-table-column prop="specificModel" label="规格型号"></el-table-column>
                    <el-table-column prop="productPrice" label="产品价格"></el-table-column>
                    <el-table-column prop="shelfLife" label="保质期(天)"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addProductInfo" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="ID编码">
                            <el-input v-model="formData.code"></el-input>
                        </el-form-item>
                        <el-form-item label="产品名称">
                            <el-input v-model="formData.productName"></el-input>
                        </el-form-item>
                        <el-form-item label="规格型号">
                            <el-input v-model="formData.specificModel"></el-input>
                        </el-form-item>
                        <el-form-item label="产品价格">
                            <el-input v-model.number="formData.productPrice"></el-input>
                        </el-form-item>
                        <el-form-item label="保质期(天)">
                            <el-input v-model="formData.shelfLife"></el-input>
                        </el-form-item>
                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addProductInfo')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqProductInfoList,
    reqAddProductInfo,
    reqUpdateProductInfo,
    reqDelProductInfo
} from "@/api/productManagement.js";

const pageSize = 10;
const rules = {};

export default {
    name: "ProductInfo",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                code: "1010",
                productName: "带骨羊前腿",
                specificModel: "AAA",
                productPrice: 168,
                shelfLife: '360'
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 产品档案列表
        this.getProductInfoList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddProductInfo(this.formData)
                            .then(res => {
                                // 产品档案列表
                                this.getProductInfoList();
                                // this.$message.success("添加成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateProductInfo(this.formData)
                            .then(res => {
                                // 产品档案列表
                                this.getProductInfoList();
                                // this.$message.success("编辑成功！");
                                if (res.errCode) {
                                    this.$message.error(res.errMsg);
                                } else {
                                    this.$message.success("成功");
                                }
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 产品档案列表 
        getProductInfoList() {
            reqProductInfoList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelProductInfo(row.id)
                .then(res => {
                    console.log(res);
                    // 产品档案列表
                    this.getProductInfoList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 产品档案列表
            this.getProductInfoList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>